#include <stdlib.h>
#include "dalloc.h"

void *
dalloc (size_t m_memb, size_t n_memb, size_t size)
{
  size_t i;
  void ** retval;

  retval = malloc(m_memb * sizeof(void *));

  if (retval == NULL)
    return NULL;

  retval[0] = malloc(m_memb * n_memb * size);

  if (retval[0] == NULL) {
    free(retval);
    return NULL;
  }

  for (i = 1; i < m_memb; i++)
    retval[i] =
      ((char *) retval[0]) + i * n_memb * size;

  return retval;
}

void
dalloc_free (void * ptr)
{
  if (ptr == NULL)
    return;

  free(* (void **) ptr);
  free(ptr);
}
